/*
** II10.ARC
**
** Models for psychiatric study, all observations
**
** Standard BRD models
**
** April 12, 1998
*/

model=1;

sensit1=0;
sensit2=0;

y1=89~13|57~65;
y2=26|49;
y3=2~0.0001;
y4=14;

n=sumc(sumc(y1))+sumc(sumc(y2))+sumc(sumc(y3))+sumc(sumc(y4));

prob1=0;
prob2=0;
prob3=0;
prob4=0;
h1=0;
h2=0;
h3=0;
h4=0;


proc logl10(param);

local p,q,pp,ll1,ll2,ll,alfa,beta,gam,delta,q1,q2,q3,q4,ll3,ll4,noemer;

p=param[1:3];
q=param[4:rows(param)];



pp=p[1]~p[2]|p[3]~(1-sumc(p));

if model==1;

   alfa=q[1];
   beta=q[2];
   gam=q[3];

elseif model==2;

   alfa=q[1];
   beta=q[2 3];
   gam=q[4];

elseif model==3;

   alfa=q[1 2]';
   beta=q[3];
   gam=q[4];

elseif model==4;

   alfa=q[1];
   beta=q[2 3]';
   gam=q[4];


elseif model==7;

   alfa=q[1 2]';
   beta=q[3 4]';
   gam=q[5];


elseif model==9;

   alfa=q[1 2]';
   beta=q[3 4];
   gam=q[5];


endif;


q4=exp(alfa+beta+gam);
q3=exp(alfa);
q2=exp(beta);
q1=1;
noemer=q1+q2+q3+q4;
q1=q1./noemer;
q2=q2./noemer;
q3=q3./noemer;
q4=q4./noemer;

h1=pp.*q1;
h2=pp.*q2;
h3=pp.*q3;
h4=pp.*q4;

prob1=h1;
prob2=sumc(h2');
prob3=sumc(h3)';
prob4=sumc(sumc(h4));

ll1=sumc(sumc(y1.*ln(prob1)));
ll2=sumc(sumc(y2.*ln(prob2)));
ll3=sumc(sumc(y3.*ln(prob3)));
ll4=sumc(sumc(y4.*ln(prob4)));

ll=ll1+ll2+ll3+ll4;

retp(-ll);
endp;


