/*
** II10.BAT
** April 12, 1998
** batch file accompanying II10.ARC
**
** Fit of overspecified BRD models
**
*/



library myproc optmum;
#include \gauss\myproc\ii\ii10.arc;

model=1;
do while model<=9;

if model==5;
   model=7;
elseif model==8;
   model=9;
endif;

if model==1;
   let param=0.37 0.05 0.27 -1 -4 3;
elseif model==2;
   let param=0.37 0.05 0.27 -1 -4 -4 3;
elseif model==3;
   let param=0.37 0.05 0.27 -1 -4 -4 3;
elseif model==4;
   let param=0.37 0.05 0.27 -1 0 0 3;
elseif model==7;
   let param=0.37 0.05 0.27 -1 -1 0 0 0;
elseif model==9;
   let param=0.37 0.05 0.27 -1 -1 0 0 0;
endif;


_opalgr=5;
_opgtol=1e-6;

{een,twee,drie,vier}=optmum(&logl10,param);

if model==1;
   output file=ii10.out reset;
else;
   output file=ii10.out on;
endif;
"II10.OUT";
datestr(date);
"Model";;format 4,0; model;" ";form;

"Parameters";
een;

"Loglikelihood";
twee;

"Predicted Complete Tables";
n*h1;n*h2;n*h3;n*h4;
"Predicted Total Table";
n*h1+n*h2+n*h3+n*h4;


"Predicted Incomplete Table";
n*prob1;n*prob2;" ";n*prob3;" ";n*prob4;

covar=inv(_opfhess);
varm1=sumc(sumc(covar[1 2,1 2]));
varm2=sumc(sumc(covar[1 3,1 3]));
pie=een[1:3];
pie=pie|(1-sumc(pie));
oddsr=pie[1]*pie[4]/pie[2]/pie[3];
loddsr=ln(oddsr);
covar=covar[1:3,1:3];
covar=covar|sumc(-covar)';
covar=covar~sumc(-covar');
f=1./pie;
f[2 3]=-f[2 3];
varlor=(f'covar*f);
marg1=pie[1]+pie[2];
marg2=pie[1]+pie[3];
"First marginal probability " marg1;
"Confidence interval        ";;marg1-1.96*sqrt(varm1);;marg1+1.96*sqrt(varm1);
"Second marginal probability" marg2;
"Confidence interval        ";;marg2-1.96*sqrt(varm2);;marg2+1.96*sqrt(varm2);
"Log Odds ratio             " loddsr;
"Confidence interval        ";;
 loddsr-1.96*sqrt(varlor);;loddsr+1.96*sqrt(varlor);
"Odds Ratio                 " oddsr;
"Confidence interval        ";;
exp(loddsr-1.96*sqrt(varlor));;exp(loddsr+1.96*sqrt(varlor));
"\f";
output off;

model=model+1;
endo;
