/*
** II11.BAT
** April 13, 1998
** batch file accompanying II11.ARC: overspecified BRD-type models
**
*/



library myproc optmum;
#include \gauss\myproc\ii\ii11.arc;

eenv={};
precc={};
princ={};
loglv={};
varm1={};
varm2={};
varlor={};

model=10;


if model==10;
let param=
0.37 0.06 0.23 -4 -3 -1.5 -0.04 3.5;
let param=
0.37 0.06 0.23 -4 -13 -1.5 -0.04 3.5;
endif;

sensitv=seqa(0,1,121)/10-6;
sensitv=seqa(0,1,161)/10-8;


tel2=1;
do while tel2<=rows(sensitv);


sensit=sensitv[tel2];


"sensit" sensit;
_opalgr=5;
{een,twee,drie,vier}=optmum(&logl11,param);
covar=inv(_opfhess);

een;" ";sensit;" ";twee;

eenv=eenv|een';
loglv=loglv|twee;
precc=precc|((h1*n)~(h2*n)~(h3*n)~(h4*n));


varm1=varm1|sumc(sumc(covar[1 2,1 2]));
varm2=varm2|sumc(sumc(covar[1 3,1 3]));
pie=een[1:3];
pie=pie|(1-sumc(pie));
covar=covar[1:3,1:3];
covar=covar|sumc(-covar)';
covar=covar~sumc(-covar');
f=1./pie;
f[2 3]=-f[2 3];
varlor=varlor|(f'covar*f);

param=een;

tel2=tel2+1;
endo;




/* Derived quantities */

probvec=eenv[.,1 2 3];
probvec=probvec~(1-sumc(probvec'));

marg1=sumc(probvec[.,1 2]');
marg2=sumc(probvec[.,1 3]');
oddsrat=prodc(probvec[.,1 4]')./prodc(probvec[.,2 3]');

loddsrat=ln(oddsrat);


se_m1=sqrt(varm1);
se_m2=sqrt(varm2);
se_lor=sqrt(varlor);

lowm1=marg1-1.96*se_m1;
uppm1=marg1+1.96*se_m1;

lowm2=marg2-1.96*se_m2;
uppm2=marg2+1.96*se_m2;

lowlor=loddsrat-1.96*se_lor;
upplor=loddsrat+1.96*se_lor;

output file=ii11.out reset;

"II11.OUT";
datestr(date);

"Interval of Ignorance for First Marginal Probability";
minc(marg1) maxc(marg1);
"Interval of Uncertainty for First Marginal Probability";
minc(lowm1) maxc(uppm1);
"Interval of Ignorance for Second Marginal Probability";
minc(marg2) maxc(marg2);
"Interval of Uncertainty for Second Marginal Probability";
minc(lowm2) maxc(uppm2);
"Interval of Ignorance for Marginal Odds Ratio";
minc(oddsrat) maxc(oddsrat);
"Interval of Uncertainty for Marginal Odds Ratio";
exp(minc(lowlor)) exp(maxc(upplor));
"Interval of Ignorance for Marginal Log Odds Ratio";
minc(loddsrat) maxc(loddsrat);
"Interval of Uncertainty for Marginal Log Odds Ratio";
minc(lowlor) maxc(upplor);
"loglikelihood" loglv[1];

output off;


/*
"Parameter Estimates";
let naam=number p11 p12 p21 alpha beta sensit;
$naam';
seqa(1,1,rows(eenv))~eenv~sensitv;
"\f";
"Marginal Probabilities and Odds Ratios: Estimates";
let naam=number sensit marg1 marg2 oddsrat;
$naam';
seqa(1,1,rows(eenv))~sensitv~marg1~marg2~oddsrat;
"\f";
"Marginal Probabilities and Odds Ratios: Variances";
let naam=number sensit v_marg1 v_marg2 v_lor;
$naam';
seqa(1,1,rows(eenv))~sensitv~varm1~varm2~varlor;
"\f";


sensitv2=seqa(1,1,rows(sensitv))~sensitv~miss(zeros(rows(sensitv),2),0);
sensitv2=reshape(sensitv2,rows(sensitv2)*2,2);
"Predicted Incomplete Tables";
sensitv2~princ;
"\f";

"Predicted Complete Tables";
sensitv2~precc;

output off;
*/



