/*
** II9.ARC
**
** (derived from NONEM12.ARC)
**
** de modellen van Baker, Rosenberger, DerSimonian (1992)
*/



z11=89~13|57~65;
z12=26|49;
z21=2~0;
z22=14;



output file=ii9a.out reset;
"II9A.OUT";
datestr(date);
timestr(time);
" ";
"DATA";
" ";"11";z11;
" ";"12";z12;
" ";"21";z21;
" ";"22";z22;" ";
"\f";
output off;

zpp11=sumc(sumc(z11));
zpp12=sumc(sumc(z12));
zpp21=sumc(sumc(z21));
zpp22=sumc(sumc(z22));

zppp1=zpp11+zpp21;
zpj11=sumc(z11)';
zpjp1=zpj11+z21;

zpp1p=zpp11+zpp12;
zip11=sumc(z11');
zip1p=zip11+z12;

model=1;
do while model<=9;


if model==1;  /* a */

   m=z11;
   t=1;
   do while t<=50;
      mip=sumc(m');
      mpj=sumc(m)';
      m=(z11+z12.*m./mip+z21.*m./mpj).*zpp11./(zpp11+zpp12+zpp21);
      locate 1,1;t;m;
   t=t+1;
   endo;

   alfa=zpp21./zpp11;
   beta=zpp12./zpp11;
   g=zpp11.*zpp22./zpp12./zpp21;

elseif model==2;  /* b1 */

   m=z11.*zpjp1.*zpp11./zpj11./zppp1;
   alfa=zpp21./zpp11;
   beta=z12./sumc(m');
   g=zpp11.*zpp22./zpp12./zpp21;

elseif model==3;  /* b2 */

   m=z11.*zip1p.*zpp11./zip11./zpp1p;
   alfa=z21./sumc(m)';
   beta=zpp12./zpp11;
   g=zpp11.*zpp22./zpp12./zpp21;

elseif model==4;  /* c1 */

   m=z11.*zpjp1.*zpp11./zpj11./zppp1;
   alfa=zpp21./zpp11;
   beta=(inv(m)*z12)';
   g=zpp11.*zpp22./zpp12./zpp21;

elseif model==5;  /* c2 */

   m=z11.*zip1p.*zpp11./zip11./zpp1p;
   alfa=inv(m)*z21';
   beta=zpp12./zpp11;
   g=zpp11.*zpp22./zpp12./zpp21;

elseif model==6;  /* d1 */

   m=z11;
   alfa=inv(z11)*z21';
   beta=z12./zip11;
   g=zpp22/sumc(sumc(sumc(m').*alfa.*beta));

elseif model==7;  /* d2 */

   m=z11;
   alfa=z21./zpj11;
   beta=(inv(z11)*z12)';
   g=zpp22/sumc(sumc(sumc(m)'.*alfa.*beta));

elseif model==8;  /* e */

   m=z11;
   alfa=inv(z11)*z21';
   beta=(inv(z11)*z12)';
   g=zpp22/sumc(sumc(m.*alfa.*beta));

elseif model==9;  /* f */

   m=z11;
   alfa=z21./zpj11;
   beta=z12./zip11;
   g=zpp22/sumc(sumc(m.*alfa.*beta));


endif;

tabel11=m;
tabel12=m.*beta;
tabel21=m.*alfa;
tabel22=m.*alfa.*beta.*g;
tabelpp=tabel11+tabel12+tabel21+tabel22;

tabel11f=tabel11;
tabel12f=sumc(tabel12');
tabel21f=sumc(tabel21)';
tabel22f=sumc(sumc(tabel22));

z21h=z21;
z21h[2]=1;
tabel21h=tabel21f;
tabel21h[2]=1;
if z22/=0;
gfit=sumc(sumc(z11.*ln(tabel11f./z11)))
    +sumc(sumc(z12.*ln(tabel12f./z12)))
    +sumc(sumc(z21h.*ln(tabel21h./z21h)))
    +sumc(sumc(z22.*ln(tabel22f./z22)));
elseif z22==0;
gfit=sumc(sumc(z11.*ln(tabel11f./z11)))
    +sumc(sumc(z12.*ln(tabel12f./z12)))
    +sumc(sumc(z21.*ln(tabel21f./z21)));
endif;
gfit=-2*gfit;


/* marginals and odds ratio berekening */

nn=sumc(sumc(z11))+sumc(sumc(z12))+sumc(sumc(z21))+sumc(sumc(z22));
prob=m.*(1+alfa+beta+alfa.*beta.*g)/nn;
marg1=prob[1,1]+prob[1,2];
marg2=prob[1,1]+prob[2,1];
oddsr=prob[1,1]*prob[2,2]/prob[1,2]/prob[2,1];


/* output */

output file=ii9a.out on;
"Model";;format 2,0; model;form;

"PARAMETERS";
"m"; m;
" ";"alpha"; alfa;
" ";"beta"; beta;
" ";"g"; g;" ";
"COMPLETE DATA TABLES";
" ";"11";tabel11;
" ";"12";tabel12;
" ";"21";tabel21;
" ";"22";tabel22;
" ";"total";tabelpp;
"OBSERVED DATA TABLES";
" ";"11";tabel11f;
" ";"12";tabel12f;
" ";"21";" ";tabel21f;" ";
"22";" ";tabel22f;" ";
"LIKELIHOOD RATIO STATISTIC";;gfit;
" ";
"MARGINAL PROBABILITIES"; prob;" ";
"FIRST MARGINAL PROBABILITY ";; marg1;
"SECOND MARGINAL PROBABILITY";; marg2;
"MARGINAL ODDS RATIO        ";;oddsr;
"\f";

output off;

model=model+1;
endo;
