/*
** II6.BAT
** April 10, 1998
** batch file accompanying II6.ARC
**
** Fit of overspecified model
**
*/


/*goto hier;*/

library myproc optmum;
#include \gauss\myproc\ii\ii6.arc;

model=4;

if model==4;
let param=0.05 0.0045 0.55 0.7492;
let param=0.38 0.05 0.33 4 0.95;
endif;

eenv={};
precc={};
princ={};
loglv={};

sensitv=seqa(-80,1,161)/10;

varm1={};
varm2={};
varlor={};

tel=1;
do while tel<=rows(sensitv);

sensit=sensitv[tel];

"sensit" sensit;
_opalgr=5;
{een,twee,drie,vier}=optmum(&logl6,param);
covar=inv(_opfhess);

een;" ";sensit;" ";twee;

eenv=eenv|een';
loglv=loglv|twee;
princ=princ|((prob1*n)~(prob2*n));
precc=precc|((h1*n)~(h2*n));


varm1=varm1|sumc(sumc(covar[1 2,1 2]));
varm2=varm2|sumc(sumc(covar[1 3,1 3]));
pie=een[1:3];
pie=pie|(1-sumc(pie));
covar=covar[1:3,1:3];
covar=covar|sumc(-covar)';
covar=covar~sumc(-covar');
f=1./pie;
f[2 3]=-f[2 3];
varlor=varlor|(f'covar*f);

param=een;

tel=tel+1;

endo;




/* Derived quantities */

probvec=eenv[.,1 2 3];
probvec=probvec~(1-sumc(probvec'));

marg1=sumc(probvec[.,1 2]');
marg2=sumc(probvec[.,1 3]');
oddsrat=prodc(probvec[.,1 4]')./prodc(probvec[.,2 3]');


output file=ii6.out reset;


"Interval of Ignorance for First Marginal Probability";
minc(marg1) maxc(marg1);
"Interval of Ignorance for Second Marginal Probability";
minc(marg2) maxc(marg2);
"Interval of Ignorance for Marginal Odds Ratio";
minc(oddsrat) maxc(oddsrat);
"loglikelihood" loglv[1];

"Parameter Estimates";
let naam=number p11 p12 p21 alpha beta sensit;
$naam';
seqa(1,1,rows(eenv))~eenv~sensitv;
"\f";
"Marginal Probabilities and Odds Ratios: Estimates";
let naam=number sensit marg1 marg2 oddsrat;
$naam';
seqa(1,1,rows(eenv))~sensitv~marg1~marg2~oddsrat;
"\f";
"Marginal Probabilities and Odds Ratios: Variances";
let naam=number sensit v_marg1 v_marg2 v_lor;
$naam';
seqa(1,1,rows(eenv))~sensitv~varm1~varm2~varlor;
"\f";


sensitv2=seqa(1,1,rows(sensitv))~sensitv~miss(zeros(rows(sensitv),2),0);
sensitv2=reshape(sensitv2,rows(sensitv2)*2,2);
"Predicted Incomplete Tables";
sensitv2~princ;
"\f";

"Predicted Complete Tables";
sensitv2~precc;

output off;




